Subject: 25.0.50; Incorrect rounding (?) when loading the Emacs.background attribute from Xresources

From: Clément Pit--Claudel <[email-masked]>
Date: Sun, 10 Jan 2016 16:19:50 -0500

Hi all,

This is a cute bug. Run the following two commands (in bash):

# Set Emacs.background in Xresources
$ xrdb <(echo "Emacs.background: #2e3436")
# Run Emacs with same background on default face
$ emacs -q --eval "(set-face-attribute 'default nil :background \"#2e3436\")"

On my machine, the two colors are not rendered the same. I've attached a screenshot. What essentially happens is that anywhere where text is drawn the background is indeed #2e3436, but on the rest of the frame it's #2d3335. Amusingly, these two colors have distinct RGB and HSL values, but their CMYK and HSB values are the same (or so says http://rgb.to/hex/2d3335 and http://rgb.to/hex/2e3436, at least).

The reason I came across this is that I use Emacs' tango-dark theme, which uses that background color. Since I didn't like Emacs popping up with a white background and immediately switching, I set the same background in my .Xresources.

To observe the bug more clearly, just take a screenshot and open it in your favourite image editor, then use the magic wand with a tolerance of 0 (see other screenshot). Or use the color picker.

What could cause this problem? A roundtripping issue with color conversions?

Clément.

In GNU Emacs 25.0.50.3 (x86_64-unknown-linux-gnu, GTK+ Version 3.10.8)
 of 2016-01-08 built on clem-w50-mint
Repository revision: fb97523fa14e0fb7f0cebe92c749629ad0ab475e
Windowing system distributor 'The X.Org Foundation', version 11.0.11501000
System Description:	Linux Mint 17.2 Rafaela

Configured features:
XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK SOUND GPM DBUS GCONF GSETTINGS
NOTIFY ACL LIBSELINUX GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB
TOOLKIT_SCROLL_BARS GTK3 X11

Important settings:
  value of $LC_TIME: en_DK.UTF-8
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: @im=ibus
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message dired format-spec rfc822 mml
mml-sec epg epg-config gnus-util mm-decode mm-bodies mm-encode
mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047
rfc2045 ietf-drums mm-util help-fns help-mode easymenu cl-loaddefs pcase
cl-lib mail-prsvr mail-utils time-date mule-util tooltip eldoc electric
uniquify ediff-hook vc-hooks lisp-float-type mwheel x-win
term/common-win x-dnd tool-bar dnd fontset image regexp-opt fringe
tabulated-list newcomment elisp-mode lisp-mode prog-mode register page
menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core frame cl-generic cham georgian utf-8-lang
misc-lang vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms
cp51932 hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese charscript case-table epa-hook jka-cmpr-hook help
simple abbrev minibuffer cl-preloaded nadvice loaddefs button faces
cus-face macroexp files text-properties overlay sha1 md5 base64 format
env code-pages mule custom widget hashtable-print-readable backquote
dbusbind inotify dynamic-setting system-font-setting font-render-setting
move-toolbar gtk x-toolkit x multi-tty make-network-process emacs)

Memory information:
((conses 16 86528 3773)
 (symbols 48 19882 0)
 (miscs 40 42 85)
 (strings 32 14576 5171)
 (string-bytes 1 417874)
 (vectors 16 11726)
 (vector-slots 8 426886 4799)
 (floats 8 164 77)
 (intervals 56 191 0)
 (buffers 976 11)
 (heap 1024 39449 1144))